/*                                                                            */
/*       xnetdb                                                               */
/*                                                                            */
/*       Copyright (C) 1991 The Ohio State University, All Rights Reserved    */
/*       Copyright (C) 1990 Henry Clark, All Rights Reserved                  */
/*                                                                            */
/*       Licensing details are in the file "License"                          */
/*                                                                            */
/*       xnetdbquery.c                                                        */
/*                                                                            */
/*       this program will go and query all interfaces for                    */
/*         their ifOperStatus and then pass the information                   */
/*         back to the map program                                            */
/*                                                                            */


#include "xnetdb.h"


main(argc, argv)

int  argc;
char *argv[];

{
  int i,j;
  int router_status;
  struct sockaddr_in remote;
  int skt;
  struct hostent *hp;
  char buf[BUFSIZ];
  FILE *cow;
  int  eof;
  char variable[100];
  int  status;
  struct sigvec siginfo;
  int  clkinit();
  char  vartype[10];
  char  result[20];
  char  string[30];
  char filename[80];


  siginfo.sv_handler = (void *) clkinit;
  siginfo.sv_onstack = 0;
  siginfo.sv_mask = SIGALRM;
  sigvec(SIGALRM, &siginfo, (struct sigvec *) 0);

                               /* first read list of things to query */

  num_things = 0;
  sprintf(filename, "%s/xnetdbquery.cf", argv[2]);
  if ((cow = fopen(filename, "r")) == NULL) {
    printf("xnetdbquery: unable to find xnetdbquery.cf!!!\n");
    exit(1);
  }
  eof = fscanf(cow, "%s %s %d %s", thing[num_things].router, 
                      thing[num_things].interface, &thing[num_things].intf_num,
                      thing[num_things].community);
  while (eof != EOF) {
    num_things++;
    eof = fscanf(cow, "%s %s %d %s", thing[num_things].router, 
                      thing[num_things].interface, &thing[num_things].intf_num,
                      thing[num_things].community);
  } 
  fclose(cow);

                              /* now read list of stuff to monitor */

  nummon = 0;

  sprintf(filename, "%s/xnetdb.cf", argv[2]);
  if ((datafile = open(filename, O_RDONLY)) == -1) {
    printf("xnetdbquery: unable to find xnetdb.cf!!!\n");
    exit(1);
  }
  while (fetch_more_data() != 0)
    if (buffer[0] != '#') {
      sscanf(buffer, "%s", string);
      if (strcmp(string, "VARIABLE") == 0) {
        sscanf(buffer, "%s %s %s %s %s", string, varmon[nummon].router, 
                               varmon[nummon].variable, varmon[nummon].vartype,
                               varmon[nummon].community);
        nummon++;
      }
    }
  close(datafile);

                              /* now go and query */

  skt = socket(AF_INET, SOCK_DGRAM, 0);
  remote.sin_family = AF_INET;
  remote.sin_port = atoi(argv[1]);
  remote.sin_addr.s_addr = INADDR_ANY;
  while (1 == 1) {
    sleep(SLEEP_TIME);
    for (i=0; i<num_things; i++) {
      sprintf(variable, "1.3.6.1.2.1.2.2.1.8.%d", thing[i].intf_num);
      status = make_snmp_query(thing[i].router, variable, thing[i].community,2);
      if (status == 0) {
        sscanf(snmp_buffer, "%s %d", result, &status);
        if (strcmp(result, "Integer") != 0) {
          printf("xnetdbquery: got a %s for ifOperStatus_%d\n", result,
                                       thing[i].intf_num);
          exit(1);
        }
      }
      else {
#ifdef DEBUG
        printf("xnetdbquery: return status %d\n", status);
#endif DEBUG
        status = 2;
      }
#ifdef DEBUG
      printf("query: router %s interface %s status %d\n", thing[i].router,
                                                    thing[i].interface, status);
#endif DEBUG
      switch (status) {
        case 1: sprintf(buf, "RTR %s INTF %s UP", 
                                           thing[i].router, thing[i].interface);
                break;
        case 2: sprintf(buf, "RTR %s INTF %s DN", 
                                           thing[i].router, thing[i].interface);
                break;
        case 3: sprintf(buf, "RTR %s INTF %s TG", 
                                           thing[i].router, thing[i].interface);
                break;
      }
      if (sendto(skt, buf, strlen(buf), 0, remote, sizeof(remote)) == -1) {
        printf("xnetdbquery: can't write to socket - errno = %d\n", errno);
        exit(1);
      }
    }

    for (i=0; i<nummon; i++) {
      status = make_snmp_query(varmon[i].router, varmon[i].variable, 
                                                        varmon[i].community, 2);
      sscanf(snmp_buffer, "%s %s", result, buf);
      if ((strcmp(result, varmon[i].vartype) == 0) && (status == 0)) {
        sprintf(buf, "VAR %s OF %s OK", varmon[i].router, varmon[i].variable);
#ifdef DEBUG
        printf("VAR %s OF %s OK", varmon[i].router, varmon[i].variable);
#endif DEBUG
      }
      else {
        sprintf(buf, "VAR %s OF %s FU", varmon[i].router, varmon[i].variable);
#ifdef DEBUG
        printf("VAR %s OF %s FU", varmon[i].router, varmon[i].variable);
#endif DEBUG
      }
      if (sendto(skt, buf, strlen(buf), 0, remote, sizeof(remote)) == -1) {
        printf("xnetdbquery: can't write to socket - errno = %d\n", errno);
        exit(1);
      }
    }

  }
}


int clkinit()

{
  longjmp(env, TRUE);
  return 0;
}


int fetch_more_data()

{
  char charbuf;
  int  cow;

  bufferlen = 0;
  while ((cow = read(datafile, &charbuf, 1)) != 0) {
    buffer[bufferlen] = charbuf;
    if (buffer[bufferlen] == '\n') break;
    bufferlen++;
  }
  buffer[bufferlen] = '\0';
  return cow;
}
